/**
 * Calcola il valor medio dei massimi 'blu' di ogni riga.<br>
 * In tutto il programma le eccezioni sono scarsamente gestite:<br>
 * in genere sono semplicemente intercettate o rilanciate.<br>
 * <br>
 * Programmi pi complessi e/o professionali dovrebbero effettivamente
 * gestire le eccezioni.<br>
 * <br>
 * Le operazioni di I/O sono in IOTools.java,
 * l'elaborazione di una singola riga  in Riga.java.
 */
 public class AnalisiPerRighe {

	/**
	 * uso: java AnalisiPerRighe [immagine].
	 *
	 * @param args l'immagine da usare (default image.png).
	 *
	 *  @throws java.lang.InterruptedException se si verifica il problema.
	 */
	public static void main(String[] args) throws InterruptedException {
		java.awt.image.BufferedImage image = IOTools.read(args[0]);
		int w = image.getWidth();
		int h = image.getHeight();
		Riga[] righe = new Riga[h];
		Thread[] threads = new Thread[h];
		for(int i=0; i<h; i++) {
			int[] rgb = image.getRGB(0, i, w, 1, null, 0, w);
			righe[i] = new Riga(rgb);
			threads[i] = new Thread(righe[i]);
		}
		for(int i=0; i<h; i++) {
			threads[i].start();
		}
		for(int i=0; i<h; i++) {
			threads[i].join();
			somma += righe[i].getMax();
		}
		somma /= h;
		System.out.println("Blu medio: "+somma);
	}

	static int somma = 0;
}