import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.*;

/**
 * La sincronizzazione avviene tramite join.<br>
 * L'applicazione  tutta in un unico sorgente.
 */
public class AnalisiPerRigheJoin implements Runnable {

	static AnalisiPerRigheJoin[] righe;
	static Thread[] threads;
	static int somma = 0;

	/**
	 * uso: java AnalisiPerRigheJoin [immagine].
	 *
	 * @param args l'immagine da usare (default image.png).
	 *
	 * @throws Exception se si verifica un problema.
	 */
	public static void main(String[] args) throws Exception {
		File f = new File(args.length>0 ? args[0] : "image.png");
		BufferedImage image = ImageIO.read(f);
		int w = image.getWidth();
		int h = image.getHeight();
		righe = new AnalisiPerRigheJoin[h];
		threads = new Thread[h];
		for(int i=0; i<h; i++) {
			righe[i] = new AnalisiPerRigheJoin(image.getRGB(0, i, w, 1, null, 0, w));
			threads[i] = new Thread(righe[i]);
		}
		for(int i=0; i<h; i++) {
			threads[i].start();
		}
		for(int i=0; i<h; i++) {
			threads[i].join();
			somma += righe[i].getMax();
		}
		System.out.println("Blu medio: "+(somma/h));
	}

	private int[] rgbArray;
	private int max = -1;
	private boolean done = false;

	AnalisiPerRigheJoin(int[] a) {
		rgbArray = a;
	}

	public void run() {
		for(int i=0; i<rgbArray.length; i++) {
			int blu = rgbArray[i] & 255;
			if(blu > max) max = blu;
		}
		done = true;
	}

	int getMax() {
		if(!done) throw new RuntimeException("done == false");
		return max;
	}

}
