import java.io.File;
import java.io.IOException;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;

/**
 * Metodi statici per l'I/O.
 */
public class IOTools {

	/**
	 * Legge una immagine.
	 *
	 * @param fileName il file immagine da leggere.
	 *
	 * @return l'immagine letta.
	 */
	public static BufferedImage read(String fileName) {
		try {
			File f = new File(fileName);
			return ImageIO.read(f);
		} catch(IOException e) {
			e.printStackTrace();
			System.exit(1);
			return null; // altrimenti il compilatore si lamenta
		}
	}

	private IOTools() {} // altrimenti javadoc mostra il costruttore di default
}
