/**
 * Trattamento di una singola riga dell'immagine.
 */
public class Riga implements Runnable {

	private int[] rgbArray;
	private int max = -1;
	private boolean done = false;

	Riga(int[] a) {
		rgbArray = a;
	}

	public void run() {
		for(int i=0; i<rgbArray.length; i++) {
			int blu = rgbArray[i] & 255;
			if(blu > max) max = blu;
		}
		done = true;
	}

	/**
	 * Restituisce il valore massimo della riga, se gi calcolato.
	 *
	 * @return il valore massimo della riga.
	 */
	public int getMax() {
		if(!done) throw new RuntimeException("done == false");
		return max;
	}

}
