import java.util.concurrent.CountDownLatch;

/**
 * Esempio di sincronizzazione tramite CountDownLatch.
 */
public class TestCountDownLatch {

	static final int N = 10;
	static CountDownLatch barrier = new CountDownLatch(N);

	/**
	 * uso: java TestCountDownLatch.
	 *
	 * @param args non usato.
	 * @throws Exception se si verifica un qualunque problema.
	 */
	public static void main(String[] args) throws Exception {
		for(int i=0; i<N; i++) {
			(new Thread() {
				public void run() {
					System.out.println(getName());
					barrier.countDown();
				}
			}).start();
		}
		barrier.await();
		System.out.println(Thread.currentThread().getName());
	}

	private TestCountDownLatch() {}
}