import java.util.concurrent.CyclicBarrier;

/**
 * Esempio di sincronizzazione tramite CyclicBarrier.
 */
public class TestCyclicBarrier {

	static final int N = 10;
	static CyclicBarrier barrier = new CyclicBarrier(N+1);

	/**
	 * uso: java TestCyclicBarrier.
	 *
	 * @param args non usato.
	 * @throws Exception se si verifica un qualunque problema.
	 */
	public static void main(String[] args) throws Exception {
		for(int i=0; i<N; i++) {
			(new Thread() {
				public void run() {
					try {
						barrier.await();
					} catch(Exception e) {}
					System.out.println(getName());
				}
			}).start();
		}
		barrier.await();
		System.out.println(Thread.currentThread().getName());
	}

	private TestCyclicBarrier() {}
}