/**
 * Esempio di sincronizzazione tramite join.
 */
public class TestJoin {

	static final int N = 10;
	static Thread[] threads = new Thread[N];

	/**
	 * uso: java TestJoin.
	 *
	 * @param args non usato.
	 * @throws Exception se si verifica un qualunque problema.
	 */
	public static void main(String[] args) throws Exception {
		for(int i=0; i<N; i++) {
			(threads[i] = new Thread() {
				public void run() {
					System.out.println(getName());
				}
			}).start();
		}
		for(int i=0; i<N; i++) {
			threads[i].join();
		}
		System.out.println(Thread.currentThread().getName());
	}

	private TestJoin() {}
}